/* ESERCIZIO (del 18-5-2018)
 Definire un ADT per Tree MUTABLE e POLIMORFI sul tipo A che etichetta 
 i nodi. Questi valori devono avere le seguenti operazioni e devono
 essere definiti in classi disposte in file organizzati similmente a 
 a quanto fatto con gli Stack.
 Le operazione hanno la seguente segnatura procedurale:
 
 getLabel: Tree<A> -> A              (label della root)
 getSons: Tree<A> -> int -> Tree<A>  (figli di root)
 add: Tree<A> -> int -> Tree<A> -> void
                                     (aggiunge come n-esimo figlio di root)
 remove: Tree<A> -> int -> void      (rimuove n-esimo figlio di root)
 
 In aggiuta si introducano i costruttori opportuni e gli additionals
 toString, equals e clone
 
 Prologo: Intero sviluppo in package di nome TreePack
 Prologo: Creare 4 file:
 1 per la API TREE<A>
 1 per la classe Tree<A>
 1 per le eccezioni, newExc
 1 per i codici di tests.
 (a) Fornire API
 (b) Fornire Stato Concreto, AF e C
 (c-d-e-f) Sviluppo:
 (c) Fornire successiva operazione nell'ordine e
     ad ogni definizione procedere con (d),(e),(f)
 (d) Completare la segnatura con le eccezioni sollevate
 (e) Aggiungere definizione classi di eccezioni relative
 (f) compilare ed eseguire test di uso
 
 */

package TreePack;

import java.io.*;
import java.util.*;

class A implements Label{
    String v;
    public A(String v){
        this.v = v;
    }
    public String toString(){
        return v;
    }
}

class Test1{//costuttori, toString
    public static void main(String[] args) {
        Tree t1 = new Tree(new A("A"),null);
        Tree t2 = new Tree(new A("B"),null);
        Tree t3 = new Tree(new A("C"),null);
        Tree t4 = new Tree(new A("D"),null);
        Vector<Tree> sons1 = new Vector<Tree>();
        sons1.add(t1);
        sons1.add(t2);
        Tree t5 = new Tree(new A("E"),sons1);
        System.out.println("t1 = " + t1);
        System.out.println("t2 = " + t2);
        System.out.println("t5 = " + t5);
    }
}
class Test2{//waitup
    //....
}
class Test5{//addAll
    //....
}

class Test6{//remove
    //....
}
